package com.logicbig.example;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import java.util.Arrays;
import java.util.List;

@Component
public class ExampleClient {

    @Autowired
    private EmployeeRepository repo;

    public void run() {
        List<Employee> employees = createEmployees();

        System.out.println(" -- saving employees --");
        System.out.println(employees);
        repo.saveAll(employees);

        System.out.println(" -- finding all employees --");
        Iterable<Employee> all = repo.findAll();
        System.out.println(all);

        System.out.println(" -- finding by dept --");
        List<Employee> list = repo.findByDept("IT");
        list.stream().forEach(System.out::println);

        System.out.println(" -- finding by salary greater than 3000 --");
        List<Employee> list2 = repo.findBySalaryGreaterThan(3000);
        list2.stream().forEach(System.out::println);

        System.out.println(" -- finding by dept=IT and salary less than 4000 --");
        List<Employee> list3 = repo.findByDeptAndSalaryLessThan("IT", 4000);
        list3.stream().forEach(System.out::println);
    }

    private List<Employee> createEmployees() {
        return Arrays.asList(
                Employee.create("Diana", "Admin", 5000),
                Employee.create("Joe", "IT", 2000),
                Employee.create("Sophia", "IT", 6000),
                Employee.create("Mike", "Sale", 4000),
                Employee.create("Rose", "IT", 3000)
        );
    }
}